Add a simple script which disassembles a single function from an object
file. Comes in handy for objtool warnings and kernel stack traces.
Originally-by: Peter Zijlstra <[email protected]>
Signed-off-by: Josh Poimboeuf <[email protected]>
---
v2:
- require gawk
scripts/objdump-func | 18 ++++++++++++++++++
1 file changed, 18 insertions(+)
create mode 100755 scripts/objdump-func
diff --git a/scripts/objdump-func b/scripts/objdump-func
new file mode 100755
index 000000000000..67229acfe3a6
--- /dev/null
+++ b/scripts/objdump-func
@@ -0,0 +1,18 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Disassemble a single function.
+#
+# usage: objdump-func <file> <func>
+
+set -o errexit
+set -o nounset
+
+OBJDUMP="${CROSS_COMPILE:-}objdump"
+
+command -v gawk >/dev/null 2>&1 || die "gawk isn't installed"
+
+OBJ=$1; shift
+FUNC=$1; shift
+
+${OBJDUMP} -wdr $@ $OBJ | gawk "/^\$/ { P=0; } /$FUNC[^>]*>:\$/ { P=1; O=strtonum(\"0x\" \$1); } { if (P) { o=strtonum(\"0x\" \$1); printf(\"%04x \", o-O); print \$0; } }"
--
2.34.1
On Tue, Apr 19, 2022 at 09:50:01PM +0200, Borislav Petkov wrote:
> On Tue, Apr 19, 2022 at 09:12:23AM -0700, Josh Poimboeuf wrote:
> > Add a simple script which disassembles a single function from an object
> > file. Comes in handy for objtool warnings and kernel stack traces.
> >
> > Originally-by: Peter Zijlstra <[email protected]>
> > Signed-off-by: Josh Poimboeuf <[email protected]>
> > ---
> > v2:
> > - require gawk
> >
> > scripts/objdump-func | 18 ++++++++++++++++++
> > 1 file changed, 18 insertions(+)
> > create mode 100755 scripts/objdump-func
>
> Was that supposed to be user-friendly too?
>
> $ ./scripts/objdump-func -h
> ./scripts/objdump-func: line 16: $1: unbound variable
>
> :-)
>
>
> It works tho:
>
> $ ./scripts/objdump-func vmlinux rewind_stack_and_make_dead
> 0000 ffffffff81001c00 <rewind_stack_and_make_dead>:
> 0000 ffffffff81001c00: 31 ed xor %ebp,%ebp
> 0000 ffffffff81001c02: 65 48 8b 04 25 d0 ec 01 00 mov %gs:0x1ecd0,%rax
> 0000 ffffffff81001c0b: 48 8d a0 58 ff ff ff lea -0xa8(%rax),%rsp
> 0000 ffffffff81001c12: e8 39 24 07 00 call ffffffff81074050 <make_task_dead>
> ^^^^
>
> I guess those zeros at the beginning are supposed to mean something...
Use the .o file and it'll work:
$ ./objdump-func.sh defconfig-build/vmlinux.o rewind_stack_and_make_dead
0000 0000000000001380 <rewind_stack_and_make_dead>:
0000 1380: 31 ed xor %ebp,%ebp
0002 1382: 65 48 8b 04 25 00 00 00 00 mov %gs:0x0,%rax 1387: R_X86_64_32S cpu_current_top_of_stack
000b 138b: 48 8d a0 58 ff ff ff lea -0xa8(%rax),%rsp
0012 1392: e8 00 00 00 00 call 1397 <preempt_schedule_thunk> 1393: R_X86_64_PLT32 make_task_dead-0x4
Now the first coloumn is the symbol relative offset, while the second
column is the section relative offset objdump normally gives you.
On Tue, Apr 19, 2022 at 09:12:23AM -0700, Josh Poimboeuf wrote:
> Add a simple script which disassembles a single function from an object
> file. Comes in handy for objtool warnings and kernel stack traces.
>
> Originally-by: Peter Zijlstra <[email protected]>
> Signed-off-by: Josh Poimboeuf <[email protected]>
> ---
> v2:
> - require gawk
>
> scripts/objdump-func | 18 ++++++++++++++++++
> 1 file changed, 18 insertions(+)
> create mode 100755 scripts/objdump-func
Was that supposed to be user-friendly too?
$ ./scripts/objdump-func -h
./scripts/objdump-func: line 16: $1: unbound variable
:-)
It works tho:
$ ./scripts/objdump-func vmlinux rewind_stack_and_make_dead
0000 ffffffff81001c00 <rewind_stack_and_make_dead>:
0000 ffffffff81001c00: 31 ed xor %ebp,%ebp
0000 ffffffff81001c02: 65 48 8b 04 25 d0 ec 01 00 mov %gs:0x1ecd0,%rax
0000 ffffffff81001c0b: 48 8d a0 58 ff ff ff lea -0xa8(%rax),%rsp
0000 ffffffff81001c12: e8 39 24 07 00 call ffffffff81074050 <make_task_dead>
^^^^
I guess those zeros at the beginning are supposed to mean something...
Thx.
--
Regards/Gruss,
Boris.
https://people.kernel.org/tglx/notes-about-netiquette
On Tue, Apr 19, 2022 at 10:14:35PM +0200, Peter Zijlstra wrote:
> On Tue, Apr 19, 2022 at 09:50:01PM +0200, Borislav Petkov wrote:
> > On Tue, Apr 19, 2022 at 09:12:23AM -0700, Josh Poimboeuf wrote:
> > > Add a simple script which disassembles a single function from an object
> > > file. Comes in handy for objtool warnings and kernel stack traces.
> > >
> > > Originally-by: Peter Zijlstra <[email protected]>
> > > Signed-off-by: Josh Poimboeuf <[email protected]>
> > > ---
> > > v2:
> > > - require gawk
> > >
> > > scripts/objdump-func | 18 ++++++++++++++++++
> > > 1 file changed, 18 insertions(+)
> > > create mode 100755 scripts/objdump-func
> >
> > Was that supposed to be user-friendly too?
> >
> > $ ./scripts/objdump-func -h
> > ./scripts/objdump-func: line 16: $1: unbound variable
> >
> > :-)
You mean you don't want to read the script to reverse engineer the usage
before running it???
> > It works tho:
> >
> > $ ./scripts/objdump-func vmlinux rewind_stack_and_make_dead
> > 0000 ffffffff81001c00 <rewind_stack_and_make_dead>:
> > 0000 ffffffff81001c00: 31 ed xor %ebp,%ebp
> > 0000 ffffffff81001c02: 65 48 8b 04 25 d0 ec 01 00 mov %gs:0x1ecd0,%rax
> > 0000 ffffffff81001c0b: 48 8d a0 58 ff ff ff lea -0xa8(%rax),%rsp
> > 0000 ffffffff81001c12: e8 39 24 07 00 call ffffffff81074050 <make_task_dead>
> > ^^^^
> >
> > I guess those zeros at the beginning are supposed to mean something...
>
> Use the .o file and it'll work:
Should probably get fixed to work on vmlinux too...
--
Josh